﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.Integration;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace DataChartHostImage
{
    public partial class Form1 : Form
    {
        string fileName = "image.bmp";
        public Form1()
        {
            InitializeComponent();
            ViewModel vm = new ViewModel();    

            XamDataChart chart = new XamDataChart() { Height = 400, Width = 400 };

            CategoryXAxis xAxis = new CategoryXAxis() { ItemsSource = vm.Data, Label = "{Label}" };
            NumericYAxis yAxis = new NumericYAxis() { MinimumValue = 0, MaximumValue = 12 };

            List<double> doubles = new List<double>();
            doubles.Add(2);

            DoubleCollection collection = new DoubleCollection(doubles);

            LineSeries series1 = new LineSeries()
            {
                XAxis = xAxis,
                YAxis = yAxis,
                ItemsSource = vm.Data,
                ValueMemberPath = "Value1",
                DashArray = collection
            };

            LineSeries series2 = new LineSeries()
            {
                XAxis = xAxis,
                YAxis = yAxis,
                ItemsSource = vm.Data,
                ValueMemberPath = "Value2",               
            };

            chart.Axes.Add(xAxis);
            chart.Axes.Add(yAxis);

            chart.Series.Add(series1);
            chart.Series.Add(series2);           

            System.Windows.Size size = new System.Windows.Size(400, 400);
            chart.Measure(size);

            chart.Arrange(new System.Windows.Rect(0, 0, size.Width, size.Height));

            chart.Flush();
            chart.UpdateLayout();

            RenderTargetBitmap rtb = new RenderTargetBitmap(400, 400, 96, 96, PixelFormats.Pbgra32);
            rtb.Render(chart);

            PngBitmapEncoder encoder = new PngBitmapEncoder();
            BitmapFrame bitmapFrame = BitmapFrame.Create(rtb);

            encoder.Frames.Add(bitmapFrame);
            
            if (File.Exists(fileName))
            {
                File.Delete(fileName);
            }            

            using(FileStream fs = new FileStream(fileName, FileMode.CreateNew, FileAccess.ReadWrite))
            {
                encoder.Save(fs);
            }

            System.Diagnostics.Process.Start(fileName);
        }
    }
}
